package calculette;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import java.util.*;

/**
 * URST Le Havre - TD l2
 * 
 * @author Damien Olivier
 * @version 1.0.0
 */

class CalculatricePanel extends JPanel implements ActionListener {
    private static String TOUCHES = "789+456-123*0.C/";
    /**
     * Affichage des valeurs saisies et des rsultats
     */
    private Afficheur affichage;
    /**
     * Le nombre de dcimales affiches
     */
    private int decimales = 2;
    private String operateur = "";
    private boolean debut = true;
    private boolean reel = false;
    private double resultat = 0;
    
    private void traiteInfo(String s)
    {
        if ('0' <= s.charAt(0) && s.charAt(0) <= '9' || s.equals("."))
        {
            if (s.equals(".")) 
                {
                	if (reel) s = "";
                	reel = true;
                }
            if (debut) affichage.setText(s);
            else affichage.setText(affichage.getText() + s);
            debut = false;
        }
        else if (debut)
        {
            if (s.equals("-"))
            {
                affichage.setText(s);
                debut = false;
            }
            else operateur = s;
        }
        else
            if (s.equals("C"))
            {
                affichage.setText("0");
                debut = true;
                reel = false;
            }
            else
            {	
                double x = Double.parseDouble(affichage.getText());
                calculer(x);
                operateur = s;
                debut = true;
                reel = false;
            }
    }
    
    class Afficheur extends JTextField implements KeyListener {
        Afficheur()
        {
            super("0");
            setEditable(false);
            addKeyListener(this);
        }
        
        
        /* (non-Javadoc)
         * @see java.awt.event.KeyListener#keyPressed(java.awt.event.KeyEvent)
         */
        public void keyPressed(KeyEvent e) {
            if ('0' <= e.getKeyChar() && e.getKeyChar() <= '9' || e.getKeyChar() == '.')
            traiteInfo(""+ e.getKeyChar());
        }
        
        /* (non-Javadoc)
         * @see java.awt.event.KeyListener#keyReleased(java.awt.event.KeyEvent)
         */
        public void keyReleased(KeyEvent e) {
            // TODO Raccord de mthode auto-gnr

        }
        /* (non-Javadoc)
         * @see java.awt.event.KeyListener#keyTyped(java.awt.event.KeyEvent)
         */
        public void keyTyped(KeyEvent e) {
            // TODO Raccord de mthode auto-gnr

        }
    }
    
    class Precision extends Box implements ActionListener {
        protected JCheckBox b1, b2, b3;
        
        Precision()
        {
            super(BoxLayout.X_AXIS);
            ButtonGroup groupe = new ButtonGroup();
            
            b1 = new JCheckBox("0"); 
            b2 = new JCheckBox("2");
            b2.setSelected(true);
            b3 = new JCheckBox("6"); 

            b1.addActionListener(this);
            b2.addActionListener(this);
            b3.addActionListener(this); 

            //On ajoute les boutons au groupe
            groupe.add(b1); groupe.add(b2); groupe.add(b3);
            //On ajoute les composants (FlowLayout) 
            createHorizontalBox();
            add(b1);add(Box.createGlue()); add(b2); add(Box.createGlue()); add(b3); 
        } 
         
        public void actionPerformed(ActionEvent e) { 
            decimales = Integer.parseInt(e.getActionCommand());
        } 
    }
    
    public CalculatricePanel() {
        super();
        // le gestionncaire de placement
        setLayout(new BorderLayout());
        // l'affichage
        affichage = new Afficheur();
        add(affichage, "North");
        add(new Precision(), "Center");
        // le panneau des chiffres et oprations
        JPanel clavier = new JPanel();
        clavier.setLayout(new GridLayout(4,4));
        for(int i = 0; i < TOUCHES.length(); i++)
            ajouteBouton(clavier, TOUCHES.substring(i, i+1));
        add(clavier,"South");
    }
    
    private void ajouteBouton(Container dans, String s)
    {
     JButton b = new JButton(s);
     dans.add(b);
     b.addActionListener(this);
    }

    /* (non-Javadoc)
     * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent e) {
        traiteInfo(e.getActionCommand());
    }
    
    public void calculer(double n)
    {
        if (operateur.equals("+")) resultat += n;
        else if (operateur.equals("-")) resultat -= n;
        	else if (operateur.equals("*")) resultat *= n;
        		else if(operateur.equals("/")) resultat /= n;	
        			else resultat = n;
        Formatter f = new Formatter();
        String chaineFormat = "%.2f";
        if (decimales == 2) chaineFormat = "%.2f";
        if (decimales == 0) chaineFormat = "%.0f";
        if (decimales == 6) chaineFormat = "%.6f";
        f.format(chaineFormat, resultat);
        String sr = f.toString();
        affichage.setText("" + sr);
    }

}
